Re: Wireless update to ifup and network-functions

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On Thu, 2004-09-16 at 16:12 -0400, Jon Nettleton wrote:
> Is there any chance you could round up those patches for me? 

It probably doesn't work well as a _patch_ since there'll be conflicts
as soon as one line in the part which we remove from ifup and put into
ifup-eth gets changed. But here it is anyway...

-- 
dwmw2
--- Begin Message ---
I'd like to make the Bluetooth networking devices work nicely as part of
our network scripts.

We get a 'virtual' Ethernet device -- currently it's created by the pand
daemon, run from /etc/init.d/pand. Users obviously can't start and stop
devices. When the daemon creates the virtual device, usually 'bnep0',
the hotplug scripts run and if we have an ifcfg-bnep0 which looks just
like a standard Ethernet device config file, it works OK.

I'd like to fix that so that the daemon can be started and stopped
with /sbin/ifup by normal users -- much like pppd. This basically means
that on ifup _without_ $IN_HOTPLUG set, we have to start the daemon,
while on ifup _with_ $IN_HOTPLUG set, we run the normal Ethernet ifup
stuff. 

But the way that $OTHERSCRIPT is handled in the ifup script doesn't make
that easy -- so I'd like to split ifup-eth out from ifup to make it
callable from elsewhere.

That may allow us to move other special-case stuff like bridging and
VLANs out from ifup/ifup-eth into their own file, too. 

I haven't finished the Bluetooth bits yet or properly tested normal
Ethernet stuff still works -- but this is an idea of what it would look
like.... comments?

Index: ifdown
===================================================================
RCS file: /usr/local/CVS/initscripts/sysconfig/network-scripts/ifdown,v
retrieving revision 1.59
diff -u -r1.59 ifdown
--- ifdown	17 Mar 2004 02:42:07 -0000	1.59
+++ ifdown	31 May 2004 08:32:07 -0000
@@ -39,109 +39,8 @@
 fi
 
 OTHERSCRIPT="/etc/sysconfig/network-scripts/ifdown-${DEVICETYPE}"
+[ -x $OTHERSCRIPT ] || OTHERSCRIPT="/etc/sysconfig/network-scripts/ifdown-eth"
 
-if [ -x $OTHERSCRIPT ]; then
-	exec $OTHERSCRIPT $CONFIG $2
-fi
+exec $OTHERSCRIPT $CONFIG $2
 
-if [ -n "${BRIDGE}" -a -x /usr/sbin/brctl ]; then
-      /sbin/ip link set dev ${DEVICE} down
-      /usr/sbin/brctl delif ${BRIDGE} ${DEVICE}
-      # Upon removing a device from a bridge,
-      # it's necessary to make radvd reload its config
-      [ -r /var/run/radvd/radvd.pid ] && kill -HUP `cat /var/run/radvd/radvd.pid`
-      exit 0
-fi 
 
-. /etc/sysconfig/network
-
-# Check to make sure the device is actually up
-check_device_down ${DEVICE} && [ "$BOOTPROTO" != "dhcp" -a "$BOOTPROTO" != "bootp" ] && [ -n "$VLAN" -a "$VLAN" != "yes" ] && exit 0
-
-if [ -n "${HWADDR}" -a -z "${MACADDR}" ]; then
-    FOUNDMACADDR=`get_hwaddr ${REALDEVICE}`
-    if [ "${FOUNDMACADDR}" != "${HWADDR}" ]; then
-        NEWCONFIG=`fgrep -il "HWADDR=${HWADDR}" /etc/sysconfig/network-scripts/ifcfg-*`
-	if [ -n "${NEWCONFIG}" -a "${NEWCONFIG}" != "${CONFIG}" ]; then
-	   exec /sbin/ifdown ${NEWCONFIG}
-	else
-	   echo $"Device ${DEVICE} has different MAC address than expected, ignoring."
-	   exit 1
-	fi
-    fi
-fi
-
-if [ "${NETWORKING_IPV6}" = "yes" ]; then
-    /etc/sysconfig/network-scripts/ifdown-ipv6 ${CONFIG}
-fi
-
-retcode=0
-if [ "$BOOTPROTO" = bootp -o "$BOOTPROTO" = dhcp ]; then
-	[ -n "`pidof -x dhclient`" ] && {
-		if [ -f "/var/run/dhclient-${DEVICE}.pid" ]; then
-		   kill `cat /var/run/dhclient-${DEVICE}.pid` >/dev/null 2>&1
-		   retcode=$?
-		fi
-	}	
-	[ -n "`pidof -x dhcpcd`" ] && {
-		if [ -f "/etc/dhcpc/dhcpcd-${DEVICE}.pid" ]; then
-		   kill `cat /etc/dhcpc/dhcpcd-${DEVICE}.pid` >/dev/null 2>&1
-		   retcode=$?
-		elif [ -f "/var/run/dhcpcd-${DEVICE}.pid" ]; then
-		   kill `cat /var/run/dhcpcd-${DEVICE}.pid` >/dev/null 2>&1
-		   retcode=$?
-		fi
-	}	
-	[ -n "`pidof -x pump`" ] && {
-	 	pump -r -i ${DEVICE}
-		retcode=$?
-	}
-else
-	# we can't just delete the configured address because that address
-	# may have been changed in the config file since the device was
-	# brought up.  Flush all addresses associated with this
-	# instance instead.
-	if [ "${REALDEVICE}" = "${DEVICE}" ]; then
-		ip addr flush dev ${REALDEVICE} 2>/dev/null
-	else
-		ip addr flush dev ${REALDEVICE} label ${DEVICE} 2>/dev/null
-	fi
-fi
-
-if [ "${REALDEVICE}" = "${DEVICE}" ]; then
-  ip link set dev ${DEVICE} down
-fi
-[ "$retcode" = "0" ] && retcode=$?
-
-# wait up to 5 seconds for device to actually come down...
-waited=0
-while ! check_device_down ${DEVICE} && [ "$waited" -lt 50 ] ; do
-    usleep 10000
-    waited=$(($waited+1))
-done
-
-# don't leave an outdated key sitting around
-if [ -n "${WIRELESS_ENC_KEY}" -a -x /sbin/iwconfig ]; then
-    /sbin/iwconfig ${DEVICE} enc 0 >/dev/null 2>&1
-fi
-
-if [ "$retcode" = 0 ] ; then
-    /etc/sysconfig/network-scripts/ifdown-post $CONFIG
-    # do NOT use $? because ifdown should return whether or not
-    # the interface went down.
-fi
-
-if [ "$TYPE" = "Bridge" -a -x /usr/sbin/brctl ]; then
-    /usr/sbin/brctl delbr ${DEVICE}
-fi
-
-if [ -n "$VLAN" -a -x /sbin/vconfig ]; then
-    # 802.1q VLAN
-    if echo ${DEVICE} | LANG=C egrep -v '(:)' | LANG=C egrep -q 'eth[0-9][0-9]*\.[0-9][0-9]?[0-9]?[0-9]?' ; then
-	[ -f /proc/net/vlan/${DEVICE} ] && {
-	    /sbin/vconfig rem ${DEVICE}
-	}
-    fi
-fi
-
-exit $retcode
Index: ifup
===================================================================
RCS file: /usr/local/CVS/initscripts/sysconfig/network-scripts/ifup,v
retrieving revision 1.163
diff -u -r1.163 ifup
--- ifup	4 May 2004 05:28:56 -0000	1.163
+++ ifup	31 May 2004 08:32:07 -0000
@@ -119,289 +119,11 @@
     fi
 fi
 
-# Old BOOTP variable
-if [ "${BOOTP}" = "yes" ]; then
-    BOOTPROTO=bootp
-fi
-
-if [ "${BOOTPROTO}" = "bootp" -o "${BOOTPROTO}" = "dhcp" ]; then
-    DYNCONFIG=true
-fi
-
 if [ -x /sbin/ifup-pre-local ]; then
     /sbin/ifup-pre-local ${CONFIG} $2
 fi
 
 OTHERSCRIPT="/etc/sysconfig/network-scripts/ifup-${DEVICETYPE}"
+[ -x ${OTHERSCRIPT} ] || OTHERSCRIPT="/etc/sysconfig/network-scripts/ifup-eth"
 
-if [ -x ${OTHERSCRIPT} ]; then
-    exec ${OTHERSCRIPT} ${CONFIG} $2
-fi
-
-# load the module associated with that device
-# /sbin/modprobe ${REALDEVICE}
-is_available ${REALDEVICE}
-
-# remap, if the device is bound with a MAC address and not the right device num
-# bail out, if the MAC does not fit
-if [ -n "${HWADDR}" ]; then
-    FOUNDMACADDR=`get_hwaddr ${REALDEVICE}`
-    if [ "${FOUNDMACADDR}" != "${HWADDR}" ]; then
-        curdev=`ip -o link | awk -F ':' -vIGNORECASE=1 '/$HWADDR/ { print $2 }'`
-        rename_device "${REALDEVICE}" "${HWADDR}" "${curdev}" || {
-	    echo $"Device ${DEVICE} has different MAC address than expected, ignoring."
-	    exit 1
-	}
-    fi
-fi
-
-if [ "${TYPE}" = "Bridge" ]; then
-      if [ ! -x /usr/sbin/brctl ]; then
-	  echo $"Bridge support not available: brctl not found"
-	  exit 1
-      fi
-      /sbin/ip link set dev ${DEVICE} down 2>/dev/null
-      /usr/sbin/brctl delbr ${DEVICE} 2>/dev/null
-      /usr/sbin/brctl addbr ${DEVICE} 2>/dev/null
-      # brctl doesn't report success/failure (BZ #104408)
-      # Test for ourselves whether it worked.
-      if ! /usr/sbin/brctl show | LANG=C grep -q "^${DEVICE}	" ; then
-	    echo $"Bridge support not available in this kernel"
-	    exit 1
-      fi
-      [ -n "${DELAY}" ] && /usr/sbin/brctl setfd ${DEVICE} ${DELAY}
-      [ -n "${GCINT}" ] && /usr/sbin/brctl setgcint ${DEVICE} ${GCINT}
-fi
-
-if [ -n "${BRIDGE}" -a -x /usr/sbin/brctl ]; then
-      /sbin/ip addr flush dev ${DEVICE} 2>/dev/null
-      /sbin/ip link set dev ${DEVICE} up
-      /usr/sbin/brctl addif ${BRIDGE} ${DEVICE}
-      # Upon adding a device to a bridge, 
-      # it's necessary to make radvd reload its config
-      [ -r /var/run/radvd/radvd.pid ] && kill -HUP `cat /var/run/radvd/radvd.pid`
-      exit 0
-fi 
-
-# now check the real state
-is_available ${REALDEVICE} || {
-      if [ "$?" = "1" ] ; then
-         echo $"$alias device ${DEVICE} does not seem to be present, delaying initialization."
-         exit 1
-      else
-         exit 0
-      fi
-}
-
-# is the device wireless? If so, configure wireless device specifics
-is_wireless_device ${DEVICE} && . ./ifup-wireless
-
-# slave device?
-if [ "${SLAVE}" = yes -a "${ISALIAS}" = no -a "${MASTER}" != "" -a \
-     -x /sbin/ifenslave ]; then
-    RFLAG="" ; [ "${RECEIVEONLY}" = yes ] && RFLAG="-r"
-
-    /sbin/ip link set dev ${DEVICE} down
-    echo $"Enslaving ${DEVICE} to ${MASTER}"
-    ifenslave ${RFLAG} "${MASTER}" "${DEVICE}"
-
-    if [ -n "$ETHTOOL_OPTS" ] ; then
-        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
-    fi
-
-    exit 0
-fi
-
-# master device?
-if [ "${TYPE}" =  "Bonding" ] || ethtool -i $DEVICE 2>/dev/null| grep -q "driver: bonding" ; then
-    /sbin/ip link set dev ${DEVICE} up
-    for device in `fgrep -l "MASTER=${DEVICE}" /etc/sysconfig/network-scripts/ifcfg-*` ; do
-        /sbin/ifup ${device##*/}
-    done
-fi
-
-# this isn't the same as the MAC in the configuration filename.  It is
-# available as a configuration option in the config file, forcing the kernel
-# to think an ethernet card has a different MAC address than it really has.
-if [ -n "${MACADDR}" ]; then
-   ip link set dev ${DEVICE} address ${MACADDR}
-fi
-if [ -n "${MTU}" ]; then
-   ip link set dev ${DEVICE} mtu ${MTU}
-fi
-
-# Is there a firewall running, and does it look like one we configured?
-FWACTIVE=
-if iptables -L -n 2>/dev/null | LC_ALL=C grep -q RH-Lokkit-0-50-INPUT ; then
-    FWACTIVE=1
-else
-    modprobe -r iptable_filter >/dev/null 2>&1
-fi
-
-# Remove any temporary references which were previously added to dhclient config
-if [ -w /etc/dhclient-${DEVICE}.conf ] && [ -x /sbin/dhclient ] ; then
-   LC_ALL=C grep -v "# temporary RHL ifup addition" /etc/dhclient-${DEVICE}.conf > /etc/dhclient-${DEVICE}.conf.ifupnew 2> /dev/null
-   cat /etc/dhclient-${DEVICE}.conf.ifupnew > /etc/dhclient-${DEVICE}.conf
-   rm -f /etc/dhclient-${DEVICE}.conf.ifupnew
-fi
-		     
-if [ -n "${DYNCONFIG}" ]; then
-    PUMPARGS=$PUMPARGS
-    DHCPCDARGS="$DHCPCDARGS -n"
-    DHCLIENTARGS="${DHCLIENTARGS} -1 -q -lf /var/lib/dhcp/dhclient-${DEVICE}.leases -pf /var/run/dhclient-${DEVICE}.pid -cf /etc/dhclient-${DEVICE}.conf"
-    if [ -n "${DHCP_HOSTNAME}" ]; then
-       # Send a host-name to the DHCP server (requ. by some dhcp servers).
-       PUMPARGS="${PUMPARGS} -h ${DHCP_HOSTNAME}"
-       DHCPCDARGS="${DHCPCDARGS} -h ${DHCP_HOSTNAME}"
-       if [ -x /sbin/dhclient ] ; then
-          if [ -w /etc/dhclient-${DEVICE}.conf ] ; then
-             if ! LC_ALL=C grep "send *host-name *\"${DHCP_HOSTNAME}\"" /etc/dhclient-${DEVICE}.conf > /dev/null 2>&1 ; then
-                echo "send host-name \"${DHCP_HOSTNAME}\";  # temporary RHL ifup addition" >> /etc/dhclient-${DEVICE}.conf
-             fi
-          elif ! [ -e /etc/dhclient-${DEVICE}.conf ] ; then
-             echo "send host-name \"${DHCP_HOSTNAME}\";  # temporary RHL ifup addition" >> /etc/dhclient-${DEVICE}.conf
-          fi
-       fi
-    fi
-    if need_hostname; then
-       # Set hostname of host to host-name option supplied by DHCP.
-       PUMPARGS="${PUMPARGS} --lookup-hostname"
-       DHCPCDARGS="${DHCPCDARGS} -H"
-    fi
-    if [ "${PEERDNS}" = "no" ]; then
-       # Do not update/replace resolv.conf.
-       PUMPARGS="${PUMPARGS} -d"
-       DHCPCDARGS="${DHCPCDARGS} -R"
-    fi
-    echo
-    echo -n $"Determining IP information for ${DEVICE}..."
-    if check_link_down ${DEVICE}; then
-	echo $" failed; no link present.  Check cable?"
-	ip link set dev ${DEVICE} down >/dev/null 2>&1
-	exit 1
-    fi
-
-    if [ -n "$ETHTOOL_OPTS" ] ; then
-        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
-    fi
-
-    # DHCP clients need DNS to be available, and we don't know
-    # what DNS server they're using until they are done.
-    FWHACK=
-    if [ -n "$FWACTIVE" -a "$FIREWALL_MODS" != "no" ]; then
-        iptables -I RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
-	FWHACK=1
-    fi
-    
-    if [ -x /sbin/dhclient ] && /sbin/dhclient ${DHCLIENTARGS} ${DEVICE} ; then
-	echo $" done."
-    elif [ -z "`pidof -x dhclient`" ] && [ -x /sbin/dhcpcd ] && /sbin/dhcpcd ${DHCPCDARGS} ${DEVICE} ; then
-	echo $" done."
-    elif [ -z "`pidof -x dhclient`" ] && [ -z "`pidof -x dhcpcd`" ] && [ -x /sbin/pump ] && /sbin/pump ${PUMPARGS} -i ${DEVICE}; then
-	echo $" done."
-    else
-	echo $" failed."
-	[ -n "$FWHACK" ] && iptables -D RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
-	exit 1
-    fi
-
-    [ -n "$FWHACK" ] && iptables -D RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
-
-    # DHCP likes to create duplicate routes.  Fix that up.
-    NUMDEFROUTES=`ip -o route | \
-                  awk '/^default/ { nlines++ } END { print nlines }'`
-    if [ -n "$NUMDEFROUTES" ] && [ "$NUMDEFROUTES" -gt 1 ]; then
-	# remove the default route for the new device (old route wins)
-	ip route del default dev ${DEVICE}
-    fi
-# end dynamic device configuration
-else 
-    if [ -z "${IPADDR}" ]; then
-         # enable device without IP, useful for e.g. PPPoE
-	 ip link set dev ${REALDEVICE} up
-	 if [ "${NETWORKING_IPV6}" = "yes" ]; then
-	    /etc/sysconfig/network-scripts/ifup-ipv6 ${CONFIG}
-	 fi
-	 exec /etc/sysconfig/network-scripts/ifup-post ${CONFIG} ${2}
-    fi
-  
-    expand_config
-    
-    [ -n "${ARP}" ] && \
-	ip link set dev ${REALDEVICE} $(toggle_value arp $ARP)
-   
-    if ! ip link set dev ${REALDEVICE} up ; then
-	echo $"Failed to bring up ${DEVICE}."
-	exit 1
-    fi
-
-    if [ -n "$ETHTOOL_OPTS" ] ; then
-        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
-    fi
-
-    if ! arping -q -c 2 -w 3 -D -I ${REALDEVICE} ${IPADDR} ; then
-	echo $"Error, some other host already uses address ${IPADDR}."
-	exit 1
-    fi
-
-    if [ "${DEVICE}" = "lo" ]; then
-    	SCOPE="scope host"
-    else
-        SCOPE=${SCOPE:-}
-    fi
-    
-    if [ -n "$SRCADDR" ]; then
-       SRC="src $SRCADDR"
-    else
-       SRC=
-    fi
-    
-    if ! LC_ALL=C ip addr ls ${REALDEVICE} | LC_ALL=C grep -q "${IPADDR}/${PREFIX}" ; then
-	 if ! ip addr add ${IPADDR}/${PREFIX} \
-	    brd ${BROADCAST:-+} dev ${REALDEVICE} ${SCOPE} label ${DEVICE}; then
-	    echo $"Error adding address ${IPADDR} for ${DEVICE}."
-	 fi
-    fi
-    
-    if [ -n "$SRCADDR" ]; then
-           sysctl -w "net.ipv4.conf.${REALDEVICE}.arp_filter=1" >/dev/null 2>&1
-    fi
-
-    # update ARP cache of neighboring computers
-    arping -q -A -c 1 -I ${REALDEVICE} ${IPADDR}
-    ( sleep 2;
-      arping -q -U -c 1 -I ${REALDEVICE} ${IPADDR} ) > /dev/null 2>&1 < /dev/null &
-
-    # Add a route for the subnet.  Replace any existing route.
-    if [ "${ISALIAS}" = no -a "${NETMASK}" != "255.255.255.255" ]; then
-	ip route replace ${NETWORK}/${PREFIX} ${SRC} ${WINDOW:+window $WINDOW} dev ${REALDEVICE}
-    fi
-
-    # Set a default route.
-    if [ -z "${GATEWAYDEV}" -o "${GATEWAYDEV}" = "${REALDEVICE}" ]; then
-	# set up default gateway. replace if one already exists
-	if [ -n "${GATEWAY}" -a "`ipcalc --network ${GATEWAY} ${NETMASK} 2>/dev/null`" = "NETWORK=${NETWORK}" ]; then
-	    ip route replace default via ${GATEWAY} ${WINDOW:+window $WINDOW} ${SRC}
-	elif [ "${GATEWAYDEV}" = "${DEVICE}" ]; then
-	    ip route replace default ${SRC} ${WINDOW:+window $WINDOW} dev ${REALDEVICE}
-	fi
-    fi
-    
-fi
-
-# Add Zeroconf route.
-if [ -z "${NOZEROCONF}" -a "${ISALIAS}" = "no" ]; then
-    ip route replace 169.254.0.0/16 dev ${REALDEVICE} 
-fi
-
-# IPv6 initialisation?
-if [ "${NETWORKING_IPV6}" = "yes" ]; then
-    /etc/sysconfig/network-scripts/ifup-ipv6 ${CONFIG}
-fi
-
-if [ "${IPX}" = yes ]; then
-       /etc/sysconfig/network-scripts/ifup-ipx ${DEVICE}
-fi
-
-exec /etc/sysconfig/network-scripts/ifup-post ${CONFIG} ${2}
-
+exec ${OTHERSCRIPT} ${CONFIG} $2
--- /dev/null	2004-02-23 21:06:18.000000000 +0000
+++ ifdown-bnep	2004-05-30 20:49:41.000000000 +0100
@@ -0,0 +1,49 @@
+#! /bin/bash
+
+. /etc/init.d/functions
+
+cd /etc/sysconfig/network-scripts
+. network-functions
+
+[ -f ../network ] && . ../network
+
+CONFIG=${1}
+
+source_config
+
+# On hotplug events, just bring the virtual device up as if it's normal Ethernet
+if [ -n "$IN_HOTPLUG" ]; then
+	exec /etc/sysconfig/network-scripts/ifdown-eth ${CONFIG} $2
+fi
+
+stop_panu()
+{
+	kill -TERM `cat /var/run/pand-${DEVICE}.pid`
+}
+
+stop_nap()
+{
+	kill -TERM `cat /var/run/pand-${DEVICE}.pid`
+	/usr/bin/pand -K
+}
+
+stop_gn()
+{
+	:
+}
+
+case "$ROLE" in
+	PANU)
+		stop_panu
+		;;
+	NAP)
+		stop_nap
+		;;
+	GN)
+		stop_gn
+		;;
+	*)
+		echo Unknown BNEP mode :$ROLE
+		;;
+esac
+
--- /dev/null	2004-02-23 21:06:18.000000000 +0000
+++ ifup-bnep	2004-05-30 20:48:57.000000000 +0100
@@ -0,0 +1,55 @@
+#! /bin/bash
+
+. /etc/init.d/functions
+
+cd /etc/sysconfig/network-scripts
+. network-functions
+
+[ -f ../network ] && . ../network
+
+CONFIG=${1}
+
+source_config
+
+# On hotplug events, just bring the virtual device up as if it's normal Ethernet
+if [ -n "$IN_HOTPLUG" ]; then
+	exec sh -x /etc/sysconfig/network-scripts/ifup-eth ${CONFIG} $2 &>/tmp/fish2
+fi
+
+start_panu()
+{
+	PANDARGS="--persist --pidfile=/var/run/pand-${DEVICE}.pid --device=${DEVICE} --autokill"
+	[ "${CACHE}" != "no" -a "${CACHE}" != "NO" ] && PANDARGS="${PANDARGS} --cache"
+	if [ "${REMOTEBDADDR}" = "" ]; then
+		PANDARGS="${PANDARGS} --search"
+	else
+		PANDARGS="${PANDARGS} --connect ${REMOTEBDADDR}"
+	fi
+	/usr/bin/pand ${PANDARGS}
+}
+
+start_nap()
+{
+	:
+}
+
+start_gn()
+{
+	:
+}
+
+case "$ROLE" in
+	PANU)
+		start_panu
+		;;
+	NAP)
+		start_nap
+		;;
+	GN)
+		start_gn
+		;;
+	*)
+		echo Unknown BNEP mode :$ROLE
+		;;
+esac
+
--- /dev/null	2004-02-23 21:06:18.000000000 +0000
+++ ifdown-eth	2004-05-31 09:31:47.275101832 +0100
@@ -0,0 +1,123 @@
+#!/bin/bash
+# Network Interface Configuration System
+# Copyright (c) 1996-2001 Red Hat, Inc. all rights reserved.
+#
+# This software may be freely redistributed under the terms of the GNU
+# public license.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+. /etc/init.d/functions
+
+cd /etc/sysconfig/network-scripts
+. network-functions
+
+[ -f ../network ] && . ../network
+
+CONFIG=${1}
+
+source_config
+
+if [ -n "${BRIDGE}" -a -x /usr/sbin/brctl ]; then
+      /sbin/ip link set dev ${DEVICE} down
+      /usr/sbin/brctl delif ${BRIDGE} ${DEVICE}
+      # Upon removing a device from a bridge,
+      # it's necessary to make radvd reload its config
+      [ -r /var/run/radvd/radvd.pid ] && kill -HUP `cat /var/run/radvd/radvd.pid`
+      exit 0
+fi 
+
+. /etc/sysconfig/network
+
+# Check to make sure the device is actually up
+check_device_down ${DEVICE} && [ "$BOOTPROTO" != "dhcp" -a "$BOOTPROTO" != "bootp" ] && [ -n "$VLAN" -a "$VLAN" != "yes" ] && exit 0
+
+if [ -n "${HWADDR}" -a -z "${MACADDR}" ]; then
+    FOUNDMACADDR=`get_hwaddr ${REALDEVICE}`
+    if [ "${FOUNDMACADDR}" != "${HWADDR}" ]; then
+        NEWCONFIG=`fgrep -il "HWADDR=${HWADDR}" /etc/sysconfig/network-scripts/ifcfg-*`
+	if [ -n "${NEWCONFIG}" -a "${NEWCONFIG}" != "${CONFIG}" ]; then
+	   exec /sbin/ifdown ${NEWCONFIG}
+	else
+	   echo $"Device ${DEVICE} has different MAC address than expected, ignoring."
+	   exit 1
+	fi
+    fi
+fi
+
+if [ "${NETWORKING_IPV6}" = "yes" ]; then
+    /etc/sysconfig/network-scripts/ifdown-ipv6 ${CONFIG}
+fi
+
+retcode=0
+if [ "$BOOTPROTO" = bootp -o "$BOOTPROTO" = dhcp ]; then
+	[ -n "`pidof -x dhclient`" ] && {
+		if [ -f "/var/run/dhclient-${DEVICE}.pid" ]; then
+		   kill `cat /var/run/dhclient-${DEVICE}.pid` >/dev/null 2>&1
+		   retcode=$?
+		fi
+	}	
+	[ -n "`pidof -x dhcpcd`" ] && {
+		if [ -f "/etc/dhcpc/dhcpcd-${DEVICE}.pid" ]; then
+		   kill `cat /etc/dhcpc/dhcpcd-${DEVICE}.pid` >/dev/null 2>&1
+		   retcode=$?
+		elif [ -f "/var/run/dhcpcd-${DEVICE}.pid" ]; then
+		   kill `cat /var/run/dhcpcd-${DEVICE}.pid` >/dev/null 2>&1
+		   retcode=$?
+		fi
+	}	
+	[ -n "`pidof -x pump`" ] && {
+	 	pump -r -i ${DEVICE}
+		retcode=$?
+	}
+else
+	# we can't just delete the configured address because that address
+	# may have been changed in the config file since the device was
+	# brought up.  Flush all addresses associated with this
+	# instance instead.
+	if [ "${REALDEVICE}" = "${DEVICE}" ]; then
+		ip addr flush dev ${REALDEVICE} 2>/dev/null
+	else
+		ip addr flush dev ${REALDEVICE} label ${DEVICE} 2>/dev/null
+	fi
+fi
+
+if [ "${REALDEVICE}" = "${DEVICE}" ]; then
+  ip link set dev ${DEVICE} down
+fi
+[ "$retcode" = "0" ] && retcode=$?
+
+# wait up to 5 seconds for device to actually come down...
+waited=0
+while ! check_device_down ${DEVICE} && [ "$waited" -lt 50 ] ; do
+    usleep 10000
+    waited=$(($waited+1))
+done
+
+# don't leave an outdated key sitting around
+if [ -n "${WIRELESS_ENC_KEY}" -a -x /sbin/iwconfig ]; then
+    /sbin/iwconfig ${DEVICE} enc 0 >/dev/null 2>&1
+fi
+
+if [ "$retcode" = 0 ] ; then
+    /etc/sysconfig/network-scripts/ifdown-post $CONFIG
+    # do NOT use $? because ifdown should return whether or not
+    # the interface went down.
+fi
+
+if [ "$TYPE" = "Bridge" -a -x /usr/sbin/brctl ]; then
+    /usr/sbin/brctl delbr ${DEVICE}
+fi
+
+if [ -n "$VLAN" -a -x /sbin/vconfig ]; then
+    # 802.1q VLAN
+    if echo ${DEVICE} | LANG=C egrep -v '(:)' | LANG=C egrep -q 'eth[0-9][0-9]*\.[0-9][0-9]?[0-9]?[0-9]?' ; then
+	[ -f /proc/net/vlan/${DEVICE} ] && {
+	    /sbin/vconfig rem ${DEVICE}
+	}
+    fi
+fi
+
+exit $retcode
--- /dev/null	2004-02-23 21:06:18.000000000 +0000
+++ ifup-eth	2004-05-30 20:49:31.000000000 +0100
@@ -0,0 +1,300 @@
+#!/bin/bash
+# Network Interface Configuration System
+# Copyright (c) 1996-2001 Red Hat, Inc. all rights reserved.
+#
+# This software may be freely redistributed under the terms of the GNU
+# public license.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+. /etc/init.d/functions
+
+cd /etc/sysconfig/network-scripts
+. network-functions
+
+[ -f ../network ] && . ../network
+
+CONFIG=${1}
+
+need_config ${CONFIG}
+
+source_config
+
+# Old BOOTP variable
+if [ "${BOOTP}" = "yes" ]; then
+    BOOTPROTO=bootp
+fi
+
+if [ "${BOOTPROTO}" = "bootp" -o "${BOOTPROTO}" = "dhcp" ]; then
+    DYNCONFIG=true
+fi
+
+# load the module associated with that device
+# /sbin/modprobe ${REALDEVICE}
+is_available ${REALDEVICE}
+
+# remap, if the device is bound with a MAC address and not the right device num
+# bail out, if the MAC does not fit
+if [ -n "${HWADDR}" ]; then
+    FOUNDMACADDR=`get_hwaddr ${REALDEVICE}`
+    if [ "${FOUNDMACADDR}" != "${HWADDR}" ]; then
+        curdev=`ip -o link | awk -F ':' -vIGNORECASE=1 '/$HWADDR/ { print $2 }'`
+        rename_device "${REALDEVICE}" "${HWADDR}" "${curdev}" || {
+	    echo $"Device ${DEVICE} has different MAC address than expected, ignoring."
+	    exit 1
+	}
+    fi
+fi
+
+if [ "${TYPE}" = "Bridge" ]; then
+      if [ ! -x /usr/sbin/brctl ]; then
+	  echo $"Bridge support not available: brctl not found"
+	  exit 1
+      fi
+      /sbin/ip link set dev ${DEVICE} down 2>/dev/null
+      /usr/sbin/brctl delbr ${DEVICE} 2>/dev/null
+      /usr/sbin/brctl addbr ${DEVICE} 2>/dev/null
+      # brctl doesn't report success/failure (BZ #104408)
+      # Test for ourselves whether it worked.
+      if ! /usr/sbin/brctl show | LANG=C grep -q "^${DEVICE}	" ; then
+	    echo $"Bridge support not available in this kernel"
+	    exit 1
+      fi
+      [ -n "${DELAY}" ] && /usr/sbin/brctl setfd ${DEVICE} ${DELAY}
+      [ -n "${GCINT}" ] && /usr/sbin/brctl setgcint ${DEVICE} ${GCINT}
+fi
+
+if [ -n "${BRIDGE}" -a -x /usr/sbin/brctl ]; then
+      /sbin/ip addr flush dev ${DEVICE} 2>/dev/null
+      /sbin/ip link set dev ${DEVICE} up
+      /usr/sbin/brctl addif ${BRIDGE} ${DEVICE}
+      # Upon adding a device to a bridge, 
+      # it's necessary to make radvd reload its config
+      [ -r /var/run/radvd/radvd.pid ] && kill -HUP `cat /var/run/radvd/radvd.pid`
+      exit 0
+fi 
+
+# now check the real state
+is_available ${REALDEVICE} || {
+      if [ "$?" = "1" ] ; then
+         echo $"$alias device ${DEVICE} does not seem to be present, delaying initialization."
+         exit 1
+      else
+         exit 0
+      fi
+}
+
+# is the device wireless? If so, configure wireless device specifics
+is_wireless_device ${DEVICE} && . ./ifup-wireless
+
+# slave device?
+if [ "${SLAVE}" = yes -a "${ISALIAS}" = no -a "${MASTER}" != "" -a \
+     -x /sbin/ifenslave ]; then
+    RFLAG="" ; [ "${RECEIVEONLY}" = yes ] && RFLAG="-r"
+
+    /sbin/ip link set dev ${DEVICE} down
+    echo $"Enslaving ${DEVICE} to ${MASTER}"
+    ifenslave ${RFLAG} "${MASTER}" "${DEVICE}"
+
+    if [ -n "$ETHTOOL_OPTS" ] ; then
+        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
+    fi
+
+    exit 0
+fi
+
+# master device?
+if [ "${TYPE}" =  "Bonding" ] || ethtool -i $DEVICE 2>/dev/null| grep -q "driver: bonding" ; then
+    /sbin/ip link set dev ${DEVICE} up
+    for device in `fgrep -l "MASTER=${DEVICE}" /etc/sysconfig/network-scripts/ifcfg-*` ; do
+        /sbin/ifup ${device##*/}
+    done
+fi
+
+# this isn't the same as the MAC in the configuration filename.  It is
+# available as a configuration option in the config file, forcing the kernel
+# to think an ethernet card has a different MAC address than it really has.
+if [ -n "${MACADDR}" ]; then
+   ip link set dev ${DEVICE} address ${MACADDR}
+fi
+if [ -n "${MTU}" ]; then
+   ip link set dev ${DEVICE} mtu ${MTU}
+fi
+
+# Is there a firewall running, and does it look like one we configured?
+FWACTIVE=
+if iptables -L -n 2>/dev/null | LC_ALL=C grep -q RH-Lokkit-0-50-INPUT ; then
+    FWACTIVE=1
+else
+    modprobe -r iptable_filter >/dev/null 2>&1
+fi
+
+# Remove any temporary references which were previously added to dhclient config
+if [ -w /etc/dhclient-${DEVICE}.conf ] && [ -x /sbin/dhclient ] ; then
+   LC_ALL=C grep -v "# temporary RHL ifup addition" /etc/dhclient-${DEVICE}.conf > /etc/dhclient-${DEVICE}.conf.ifupnew 2> /dev/null
+   cat /etc/dhclient-${DEVICE}.conf.ifupnew > /etc/dhclient-${DEVICE}.conf
+   rm -f /etc/dhclient-${DEVICE}.conf.ifupnew
+fi
+		     
+if [ -n "${DYNCONFIG}" ]; then
+    PUMPARGS=$PUMPARGS
+    DHCPCDARGS="$DHCPCDARGS -n"
+    DHCLIENTARGS="${DHCLIENTARGS} -1 -q -lf /var/lib/dhcp/dhclient-${DEVICE}.leases -pf /var/run/dhclient-${DEVICE}.pid -cf /etc/dhclient-${DEVICE}.conf"
+    if [ -n "${DHCP_HOSTNAME}" ]; then
+       # Send a host-name to the DHCP server (requ. by some dhcp servers).
+       PUMPARGS="${PUMPARGS} -h ${DHCP_HOSTNAME}"
+       DHCPCDARGS="${DHCPCDARGS} -h ${DHCP_HOSTNAME}"
+       if [ -x /sbin/dhclient ] ; then
+          if [ -w /etc/dhclient-${DEVICE}.conf ] ; then
+             if ! LC_ALL=C grep "send *host-name *\"${DHCP_HOSTNAME}\"" /etc/dhclient-${DEVICE}.conf > /dev/null 2>&1 ; then
+                echo "send host-name \"${DHCP_HOSTNAME}\";  # temporary RHL ifup addition" >> /etc/dhclient-${DEVICE}.conf
+             fi
+          elif ! [ -e /etc/dhclient-${DEVICE}.conf ] ; then
+             echo "send host-name \"${DHCP_HOSTNAME}\";  # temporary RHL ifup addition" >> /etc/dhclient-${DEVICE}.conf
+          fi
+       fi
+    fi
+    if need_hostname; then
+       # Set hostname of host to host-name option supplied by DHCP.
+       PUMPARGS="${PUMPARGS} --lookup-hostname"
+       DHCPCDARGS="${DHCPCDARGS} -H"
+    fi
+    if [ "${PEERDNS}" = "no" ]; then
+       # Do not update/replace resolv.conf.
+       PUMPARGS="${PUMPARGS} -d"
+       DHCPCDARGS="${DHCPCDARGS} -R"
+    fi
+    echo
+    echo -n $"Determining IP information for ${DEVICE}..."
+    if check_link_down ${DEVICE}; then
+	echo $" failed; no link present.  Check cable?"
+	ip link set dev ${DEVICE} down >/dev/null 2>&1
+	exit 1
+    fi
+
+    if [ -n "$ETHTOOL_OPTS" ] ; then
+        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
+    fi
+
+    # DHCP clients need DNS to be available, and we don't know
+    # what DNS server they're using until they are done.
+    FWHACK=
+    if [ -n "$FWACTIVE" -a "$FIREWALL_MODS" != "no" ]; then
+        iptables -I RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
+	FWHACK=1
+    fi
+    
+    if [ -x /sbin/dhclient ] && /sbin/dhclient ${DHCLIENTARGS} ${DEVICE} ; then
+	echo $" done."
+    elif [ -z "`pidof -x dhclient`" ] && [ -x /sbin/dhcpcd ] && /sbin/dhcpcd ${DHCPCDARGS} ${DEVICE} ; then
+	echo $" done."
+    elif [ -z "`pidof -x dhclient`" ] && [ -z "`pidof -x dhcpcd`" ] && [ -x /sbin/pump ] && /sbin/pump ${PUMPARGS} -i ${DEVICE}; then
+	echo $" done."
+    else
+	echo $" failed."
+	[ -n "$FWHACK" ] && iptables -D RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
+	exit 1
+    fi
+
+    [ -n "$FWHACK" ] && iptables -D RH-Lokkit-0-50-INPUT -m udp -s 0/0 --sport 53 -d 0/0 --dport 1025:65535 -p udp -j ACCEPT
+
+    # DHCP likes to create duplicate routes.  Fix that up.
+    NUMDEFROUTES=`ip -o route | \
+                  awk '/^default/ { nlines++ } END { print nlines }'`
+    if [ -n "$NUMDEFROUTES" ] && [ "$NUMDEFROUTES" -gt 1 ]; then
+	# remove the default route for the new device (old route wins)
+	ip route del default dev ${DEVICE}
+    fi
+# end dynamic device configuration
+else 
+    if [ -z "${IPADDR}" ]; then
+         # enable device without IP, useful for e.g. PPPoE
+	 ip link set dev ${REALDEVICE} up
+	 if [ "${NETWORKING_IPV6}" = "yes" ]; then
+	    /etc/sysconfig/network-scripts/ifup-ipv6 ${CONFIG}
+	 fi
+	 exec /etc/sysconfig/network-scripts/ifup-post ${CONFIG} ${2}
+    fi
+  
+    expand_config
+    
+    [ -n "${ARP}" ] && \
+	ip link set dev ${REALDEVICE} $(toggle_value arp $ARP)
+   
+    if ! ip link set dev ${REALDEVICE} up ; then
+	echo $"Failed to bring up ${DEVICE}."
+	exit 1
+    fi
+
+    if [ -n "$ETHTOOL_OPTS" ] ; then
+        /sbin/ethtool -s ${REALDEVICE} $ETHTOOL_OPTS
+    fi
+
+    if ! arping -q -c 2 -w 3 -D -I ${REALDEVICE} ${IPADDR} ; then
+	echo $"Error, some other host already uses address ${IPADDR}."
+	exit 1
+    fi
+
+    if [ "${DEVICE}" = "lo" ]; then
+    	SCOPE="scope host"
+    else
+        SCOPE=${SCOPE:-}
+    fi
+    
+    if [ -n "$SRCADDR" ]; then
+       SRC="src $SRCADDR"
+    else
+       SRC=
+    fi
+    
+    if ! LC_ALL=C ip addr ls ${REALDEVICE} | LC_ALL=C grep -q "${IPADDR}/${PREFIX}" ; then
+	 if ! ip addr add ${IPADDR}/${PREFIX} \
+	    brd ${BROADCAST:-+} dev ${REALDEVICE} ${SCOPE} label ${DEVICE}; then
+	    echo $"Error adding address ${IPADDR} for ${DEVICE}."
+	 fi
+    fi
+    
+    if [ -n "$SRCADDR" ]; then
+           sysctl -w "net.ipv4.conf.${REALDEVICE}.arp_filter=1" >/dev/null 2>&1
+    fi
+
+    # update ARP cache of neighboring computers
+    arping -q -A -c 1 -I ${REALDEVICE} ${IPADDR}
+    ( sleep 2;
+      arping -q -U -c 1 -I ${REALDEVICE} ${IPADDR} ) > /dev/null 2>&1 < /dev/null &
+
+    # Add a route for the subnet.  Replace any existing route.
+    if [ "${ISALIAS}" = no -a "${NETMASK}" != "255.255.255.255" ]; then
+	ip route replace ${NETWORK}/${PREFIX} ${SRC} ${WINDOW:+window $WINDOW} dev ${REALDEVICE}
+    fi
+
+    # Set a default route.
+    if [ -z "${GATEWAYDEV}" -o "${GATEWAYDEV}" = "${REALDEVICE}" ]; then
+	# set up default gateway. replace if one already exists
+	if [ -n "${GATEWAY}" -a "`ipcalc --network ${GATEWAY} ${NETMASK} 2>/dev/null`" = "NETWORK=${NETWORK}" ]; then
+	    ip route replace default via ${GATEWAY} ${WINDOW:+window $WINDOW} ${SRC}
+	elif [ "${GATEWAYDEV}" = "${DEVICE}" ]; then
+	    ip route replace default ${SRC} ${WINDOW:+window $WINDOW} dev ${REALDEVICE}
+	fi
+    fi
+    
+fi
+
+# Add Zeroconf route.
+if [ -z "${NOZEROCONF}" -a "${ISALIAS}" = "no" ]; then
+    ip route replace 169.254.0.0/16 dev ${REALDEVICE} 
+fi
+
+# IPv6 initialisation?
+if [ "${NETWORKING_IPV6}" = "yes" ]; then
+    /etc/sysconfig/network-scripts/ifup-ipv6 ${CONFIG}
+fi
+
+if [ "${IPX}" = yes ]; then
+       /etc/sysconfig/network-scripts/ifup-ipx ${DEVICE}
+fi
+
+exec /etc/sysconfig/network-scripts/ifup-post ${CONFIG} ${2}
+


-- 
dwmw2

--- End Message ---

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[Index of Archives]     [Fedora Announce]     [Fedora Kernel]     [Fedora Testing]     [Fedora Formulas]     [Fedora PHP Devel]     [Kernel Development]     [Fedora Legacy]     [Fedora Maintainers]     [Fedora Desktop]     [PAM]     [Red Hat Development]     [Gimp]     [Yosemite News]
  Powered by Linux